<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +----------------------------------------------------------------------+
// | PHP version 4                                                        |
// +----------------------------------------------------------------------+
// | Copyright (c) 1997-2002 The PHP Group                                |
// +----------------------------------------------------------------------+
// | This source file is subject to version 2.0 of the PHP license,       |
// | that is bundled with this package in the file LICENSE, and is        |
// | available through the world-wide-web at                              |
// | http://www.php.net/license/2_02.txt.                                 |
// | If you did not receive a copy of the PHP license and are unable to   |
// | obtain it through the world-wide-web, please send a note to          |
// | license@php.net so we can mail you a copy immediately.               |
// +----------------------------------------------------------------------+
// | Authors: Byrne Reese <byrne at majordojo dot com                     |
// +----------------------------------------------------------------------+
//
// $Id: release.php,v 1.4 2003/06/14 05:21:53 byrnereese Exp $

require_once("pmi.inc");
require_once("directory.inc");

if ($_GET['id'] == "") {
  show_error("No release if specified.".
	     $PMI_HEADER_FILE,$PMI_FOOTER_FILE);
}

$release = new Release;
$release->id = $_GET['id'];
$release->load_from_db();
$release->get_projects();
$release->get_milestones();

$PAGE_TITLE = "$release->name";
include $PMI_HEADER_FILE; 

$bct = new BreadCrumbTrail;
$bct->addCrumb("PMI","."); 
$bct->addCrumb($release->name,""); 
echo $bct->toString(); 

?><br /><br />

<table cellspacing="0" cellpadding="2" border="0" width="100%">
  <tr valign="top">
    <td width="30%">
      <!-- LEFT COLUMN BEGIN -->
      <table cellpadding="2" cellspacing="0" border="0" width="100%">
        <tr class="heading">
          <td>&nbsp;Release Properties</td>
<?php
if ($_CURRENT_USER->get_permission('pmi','edit_release')) {
  echo "<td align=\"right\"><a class=\"buttonLink\" href=\"release_edit.php?id=".$release->id."\">[ Edit ]</a></td>";
}
?>
        </tr>
      </table><br />
      <b><?php echo $release->name?></b><br />
      <?php echo $release->description?><br /><br />

      <table cellpadding="2" cellspacing="0" border="0" width="100%">
        <tr class="heading">
          <td>&nbsp;Projects in this Release</td>
<?php
if ($_CURRENT_USER->get_permission('pmi','edit_release')) {
  echo "<td align=\"right\"><a class=\"buttonLink\" href=\"projects/project_create.php?releaseId=".$release->id."&returnto=".returnto_url_enc()."\">[ Add Project ]</a></td>";
}
?>
        </tr>
      </table>
<?php
  if (count($release->projects) > 0) {
    while (list($i,$prj) = each($release->projects)) {
      echo "<a href=\"projects/project.php?id=$prj->id\">$prj->name</a><br>";
    }
    reset($release->projects);
  }
  echo "<br /><br />";
?>
<br /><br />
      <!-- LEFT COLUMN END -->
    </td>
    <td>&nbsp;</td>
    <td width="<?php echo ($BUGZILLA_INTEGRATION ? "40" : "70")?>%">
      <!-- CENTER COLUMN BEGIN -->
      <table cellpadding="2" cellspacing="0" border="0" width="100%">
        <tr class="heading">
          <td>&nbsp;Release Calendar</td>
<?php
if ($_CURRENT_USER->get_permission('pmi','edit_release')) {
  echo "<td align=\"right\"><a class=\"buttonLink\" href=\"milestones/milestone_list.php?releaseId=".$release->id."\">[ Edit ]</a></td>";
}
?>
        </tr>
      </table>
<?php 
  if (count($release->milestones) == 0) {
    echo "There are no milestones associated with this release."; 
  } else {
?>
      <table cellpadding=3 cellspacing=0 border=0 width="100%">
        <tr class="tblHeading">
          <td>Milestone Name</td>
          <td>Date</td>
          <td>Status</td>
        </tr>
<?php
    while (list($i,$ms) = each($release->milestones)) {
      echo "        <tr valign=\"top\"".($i % 2 == 1 ? " class=\"altRowBg\"" : "").">";
?>
          <td><?php echo $ms->name?></td>
          <td><?php echo $ms->milestone_date?></td>
          <td><?php echo $ms->status?></td>
        </tr>
<?php
    }
    echo "      </table>";  
  }
?>
      <!-- CENTER COLUMN END -->
    </td>
<?php
if ($BUGZILLA_INTEGRATION) { 
?>
    <td>&nbsp;</td><td width="30%">

      <!-- RIGHT COLUMN BEGIN -->
<?php 
  $BUGZILLA_MILESTONE = $release->bugzilla_milestone;
  include "fragments/bug_stats.php";
?>
      <!-- RIGHT COLUMN END -->
    </td>
<?php
}
?>
  </tr>
</table>
<?php
include $PMI_FOOTER_FILE; 
?>
