<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +----------------------------------------------------------------------+
// | PHP version 4                                                        |
// +----------------------------------------------------------------------+
// | Copyright (c) 1997-2002 The PHP Group                                |
// +----------------------------------------------------------------------+
// | This source file is subject to version 2.0 of the PHP license,       |
// | that is bundled with this package in the file LICENSE, and is        |
// | available through the world-wide-web at                              |
// | http://www.php.net/license/2_02.txt.                                 |
// | If you did not receive a copy of the PHP license and are unable to   |
// | obtain it through the world-wide-web, please send a note to          |
// | license@php.net so we can mail you a copy immediately.               |
// +----------------------------------------------------------------------+
// | Authors: Byrne Reese <byrne at majordojo dot com                     |
// +----------------------------------------------------------------------+
//
// $Id: pmi.inc,v 1.3 2003/06/12 13:56:29 byrnereese Exp $

include_once("pmi.conf");
require_once("users.inc");

connect_to_pmi_db();

function connect_to_pmi_db() {
  global $CONNECTED_TO_PMI_DB;
  if (isset($CONNECTED_TO_PMI_DB)) { return; }
  global $PMI_DBHOST,$PMI_DB, $PMI_DBUSER, $PMI_DBPASS;
  if (!mysql_connect($PMI_DBHOST, $PMI_DBUSER, $PMI_DBPASS)) {
     echo "could not connect ($PMI_DBHOST, $PMI_DBUSER, $PMI_DBPASS)"; 	
  }
  if (!mysql_select_db($PMI_DB)) {
     echo "could not select ($PMI_DB)"; 	
  }
  $CONNECTED_TO_PMI_DB = 1;
}

function getBugzillaMilestones() {
  global $BUGZILLA_DB,$PMI_DB,$BUGZILLA_INTEGRATION;
  if (!$BUGZILLA_INTEGRATION) { return array(); }
  $sql = "SELECT DISTINCT value from $BUGZILLA_DB.milestones ORDER BY value";
  $query = mysql_query($sql) or die ("The bugzilla query failed! (".mysql_error().")"); 
  $list = "";
  if (mysql_num_rows($query) > 0) {
    $list = array();
    while (list($milestone) = mysql_fetch_row($query)) {
      $list[] = $milestone;
    }
  }
  return $list;
}

function getAllReleases() {
  global $PMI_DB;
  $sql = "SELECT releaseId,releaseNumber FROM $PMI_DB.Releases ORDER BY releaseNumber";
  $query = mysql_query($sql) or die ("The query failed! (".mysql_error().")"); 
  $list = array();
  if (mysql_num_rows($query) > 0) {
    while (list($id,$name) = mysql_fetch_row($query)) {
      $list[$id] = $name;
    }
  }
  return $list;
}

class Event {
  var $id;
  var $foreign_key;
  var $type;
  var $description;

  function insert_event($type,$foreign_key,$description) {
    global $PMI_DB,$_CURRENT_USER;
    $sql = sprintf("
    INSERT INTO $PMI_DB.events 
                (foreign_key,event_type,event_time,event_description) 
         VALUES (%d,'%s',NOW(),'%s')",
		$foreign_key,$type,mysql_escape_string($description));	
    $query = mysql_query($sql);
  }
  function insert_category_event($id,$desc) {
    return $this->insert_event('category',$id,$desc);
  }
  function insert_project_event($id,$desc) {
    return $this->insert_event('project',$id,$desc);
  }
  
}

class Milestone {
  var $id;
  var $release_id;
  var $name;
  var $duration;
  var $status;
  var $milestone_date;
  var $milestone_day;
  var $milestone_year;
  var $milestone_month;
}
 
class Release {
  var $id;
  var $name;
  var $releaseNumber;
  var $status;
  var $description;
  var $projects;
  var $bugzilla_milestone;
  var $milestones;

  function get_milestones() {
    global $PMI_DB;
    $sql = sprintf("
     SELECT milestone_id,name,duration,status,
            DATE_FORMAT(milestone_date,'%%M %%d, %%Y'),DATE_FORMAT(milestone_date,'%%c'),
            DATE_FORMAT(milestone_date,'%%d'),DATE_FORMAT(milestone_date,'%%Y') 
       FROM $PMI_DB.release_milestones m 
      WHERE release_id=%d 
   ORDER BY milestone_date",$this->id);
    $query = mysql_query($sql) or die ("The query failed! (".mysql_error().")"); 
    $this->milestones = array();
    if (mysql_num_rows($query) > 0) {
      while (list($id,$name,$dur,$status,$date,$month,$day,$year) = mysql_fetch_row($query)) {
        $ms = new Milestone;
        $ms->id = $id;
        $ms->release_id = $this->id;
        $ms->name = $name;
        $ms->status = $status;
        $ms->duration = $dur;
        $ms->milestone_date = $date;
        $ms->milestone_day = $day;
        $ms->milestone_month = $month;
        $ms->milestone_year = $year;
        $this->milestones[] = $ms;
      }
    }
    return $this->milestones;
  }

  function get_projects($order="name") {
    global $USERS_DB,$PMI_DB;
    $sql = sprintf("
          SELECT project_id,category_id,bugzilla_keyword,codename,name,p.status,description,
                 priority,manager_id,u.email 
            FROM $PMI_DB.projects p 
 LEFT OUTER JOIN $USERS_DB.Users u ON userId=manager_id 
           WHERE release_id=%d 
        ORDER BY $order",$this->id);
    $query = mysql_query($sql) or die ("The query failed! (".mysql_error().")"); 
    $this->projects = array();
    if (mysql_num_rows($query) > 0) {
      while (list($id,$cat,$key,$code,$name,$status,$desc,$pri,$m_id,$m_email) = mysql_fetch_row($query)) {
        $prj = new Project;
        $prj->id = $id;
        $prj->bugzilla_keyword = $key;
        $prj->category_id = $cat;
        $prj->codename = $code;
        $prj->name = $name;
        $prj->status = $status;
        $prj->description = $description;
        $prj->priority = $priority;
        $prj->ownerId = $oId;
        $prj->managerId = $mId;
        $prj->get_team();
        $this->projects[] = $prj;
      }
    }
    return $this->projects;
  }

  // given a code name, this will initialize a project object
  function load_from_db() {
    global $PMI_DB;
    $sql = "SELECT releaseId,bugzilla_milestone,releaseNumber,name,mailingList,status,description FROM $PMI_DB.Releases WHERE releaseId='".$this->id."'";
    $query = mysql_query($sql) or die ("The query failed! (".mysql_error().")"); 
    if (mysql_num_rows($query) > 0) {
      if (!(list($this->id,$this->bugzilla_milestone,$this->releaseNumber,$this->name,$this->mailingList,$this->status,$this->description) = mysql_fetch_row($query))) {
        echo "Could not fetch project info.";
      }
    }
  }
}

class Project {
  var $id;
  var $category_id;
  var $show_sub_categories;
  var $codename;
  var $name;
  var $status;
  var $description;
  var $priority;
  var $manager_id;
  var $manager_email;
  var $bugzilla_keyword;
  var $team;

  function get_team() {
    global $USERS_DB,$PMI_DB;
    if (isset($this->id) && !is_array($this->team)) {
      $this->team = array();
      $sql = sprintf("
      SELECT firstName,lastName,u.userId,role,title,email 
        FROM $USERS_DB.Users u, $USERS_DB.Profiles a, $PMI_DB.ProjectTeamMembers b 
       WHERE b.projectId=%d 
         AND u.userId=a.userId 
         AND a.userId=b.userId 
    ORDER BY lastName, firstName",$this->id);
      $query = mysql_query($sql) or die ("The query failed! (".mysql_error().")"); 
      if (mysql_num_rows($query) > 0) {
        while (list($fname, $lname, $tid, $role, $title, $email) = mysql_fetch_row($query)) {
          $tm = new TeamMember;
          $tm->id = $tid; $tm->first_name = $fname; $tm->last_name = $lname; 
          $tm->title = $title; $tm->role = $role; $tm->email = $email;
          $this->team[] = $tm;  
        }
      }
    }
  }

  function load_from_db() {
    global $USERS_DB,$PMI_DB;
    $sql = "
          SELECT project_id,release_id,category_id,bugzilla_keyword,show_sub_categories,
                 codename,name,p.status,description,priority,manager_id,u.email 
            FROM $PMI_DB.projects p 
 LEFT OUTER JOIN $USERS_DB.Users u ON manager_id=userId 
           WHERE p.project_id=".$this->id;
    $query = mysql_query($sql) or die ("The query failed! (".mysql_error().")"); 
    if (mysql_num_rows($query) > 0) {
      while (list($id,$rid,$cid,$key,$show,$code,$name,$status,$desc,$pri,$m_id,$m_email) = mysql_fetch_row($query)) {
        $this->id = $id;
        $this->bugzilla_keyword = $key;
        $this->show_sub_categories = ($show == "true" ? 1 : 0);
        $this->category_id = $cid;
        $this->release_id = $rid;
        $this->codename = $code;
        $this->name = $name;
        $this->status = $status;
        $this->description = $desc;
        $this->priority = $priority;
        $this->manager_id = $m_id;
        $this->manager_email = $m_email;
        $this->get_team();
      }
    }
  }

}

class TeamMember {
  var $id;
  var $first_name;
  var $last_name;
  var $title;
  var $role;
  var $email;

  function getFullName() {
    return "$this->last_name, $this->first_name";
  }
 
  function toString() {
    $u = new User;
    $u->id = $this->id;
    $str = "<a href=\"".getProfileURL($u)."\">".$this->getFullName()."</a> - ";
    $str .= ($this->role != "" ? $this->role : $this->title);
    return $str;
  }
}

?>